Attribute VB_Name = "infos"
Option Explicit
'Api Info Nom Utilisateur
Declare Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long
'Api Info Nom de l'Ordinateur
Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Declare Function SetComputerName Lib "kernel32" Alias "SetComputerNameA" (ByVal lpComputerName As String) As Long
'Cette API permet de savoir la quantit de mmoire physique et virtuelle disponible sur l'ordinateur ainsi que l'espace libre.
Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYSTATUS)
Type MEMORYSTATUS 'Utilise une structure MEMORYSTATUS pour stocker le rsultat.
    dwLength As Long 'dwLength est la taille de la structure.
    dwMemoryLoad As Long 'dwMemoryLoad est le pourcentage de mmoire actuellement utilis.
    dwTotalPhys As Long 'dwTotalPhys est la taille totale de la mmoire physique (en octets).
    dwAvailPhys As Long 'dwAvailPhys est la taille de la mmoire physique disponible (en octets).
    dwTotalPageFile As Long 'dwTotalPageFile donne la taille totale que peut atteindre le fichier d'change (en octets).
    dwAvailPageFile As Long 'dwAvailPageFile indique l'espace disponible dans le fichier d'change (en octets).
    dwTotalVirtual As Long 'dwTotalVirtual retourne la mmoire totale pouvant tre utilise par l'application courante (en octets).
    dwAvailVirtual As Long 'dwAvailVirtual reprsente l'espace libre totale (en octets).
End Type
'Api pour Lecture de la base de Registre*****************************
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, _
 ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, _
    ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long


Public Const KEY_ALL_ACCESS As Long = &HF0063
Public Const ERROR_SUCCESS As Long = 0
Public Const REG_SZ As Long = 1
'API pour connaitre le nombre Couleurs utilises
Declare Function GetDesktopWindow Lib "user32" () As Long
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
' Dclarations de constantes
Private Const BITSPIXEL = 12
Private Const PLANES = 14
'************************************************************
Public Function NbCouleurs() As String ' Cette fonction retourne le nombre de couleurs actuellement utilises sous Windows
Dim lgDC As Long, lgRep As Long, lgNb As Double
lgDC = GetDC(GetDesktopWindow)
lgNb = GetDeviceCaps(lgDC, PLANES) * 2 ^ GetDeviceCaps(lgDC, BITSPIXEL)
lgRep = ReleaseDC(GetDesktopWindow, lgDC)
If lgNb = 65536 Then NbCouleurs = " (16 bits)"
If lgNb = 4294967296# Then NbCouleurs = " (32 bits)"
NbCouleurs = CStr(lgNb) & " Couleurs" & NbCouleurs
End Function
Function RegLireChaine(hInKey As Long, ByVal SousClef$, ByVal valname$) As String
Dim strChaine As String, hSousClef As Long, dwType As Long, v As String, SZ As Long, R As Long
strChaine = ""
R = RegOpenKeyEx(hInKey, SousClef$, 0, KEY_ALL_ACCESS, hSousClef)
If R <> ERROR_SUCCESS Then GoTo Quitter
SZ = 256: v = String$(SZ, 0): R = RegQueryValueEx(hSousClef, valname$, 0, dwType, ByVal v, SZ)
If R = ERROR_SUCCESS And dwType = REG_SZ Then strChaine = Left$(v, SZ) Else strChaine = " "
If hInKey = 0 Then R = RegCloseKey(hSousClef)
Quitter:
        RegLireChaine = Left(strChaine, Len(strChaine) - 1)
End Function
Public Function InfoCpu() As String ' Lire le type d'ordinateur
        InfoCpu = RegLireChaine(HKEY_LOCAL_MACHINE, "Hardware\Description\System\CentralProcessor\0", "Identifier")
End Function
Public Function InfoMmx() As String ' Lire le MMX Identificateur
        InfoMmx = RegLireChaine(HKEY_LOCAL_MACHINE, "Hardware\Description\System\CentralProcessor\0", "MMXIdentifier")
End Function
Public Function InfoVendor() As String ' Lire le Vendor Identification
        InfoVendor = RegLireChaine(HKEY_LOCAL_MACHINE, "Hardware\Description\System\CentralProcessor\0", "VendorIdentifier")
End Function
Public Function WinName() As String ' Lire le nom de la Version
        WinName = RegLireChaine(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion", "Version")
End Function
Public Function WinVers() As String    ' Lire la Version
        WinVers = RegLireChaine(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion", "VersionNumber")
End Function
Public Function WinUserName() As String ' Lire utilisateur enregistr
        WinUserName = RegLireChaine(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion", "RegisteredOwner")
End Function
Public Function WinNumLicense() As String     ' Lire le numro de license
        WinNumLicense = RegLireChaine(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion", "ProductID")
End Function
Public Function WinKeySave() As String ' Lire la cle d'enregistrement
        WinKeySave = RegLireChaine(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion", "ProductKey")
End Function
Public Function ComputerName() As String ' Retourne le nom de l'ordinateur
Dim stTmp As String, lgTmp As Long
stTmp = Space$(250): lgTmp = 251
Call GetComputerName(stTmp, lgTmp)
ComputerName = Split(stTmp, Chr$(0))(0)
End Function
Public Function UserName() As String 'Retourne le nom de l'utilisateur
    Dim Ch As String, a As Long, b As Long
    a = 199: Ch = String$(200, 0): b = GetUserName(Ch, a)
    If b <> 0 Then UserName = Left$(Ch, a) Else UserName = ""
End Function


