Attribute VB_Name = "Module2"
Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128
End Type
Global MonOs As OSVERSIONINFO

Public Const VER_PLATFORM_WIN32_NT = 2
Public Const VER_PLATFORM_WIN32_WINDOWS = 1
Public Const VER_PLATFORM_WIN32s = 0


Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

Private Const gintMAX_SIZE% = 255                        ' Taille maximum de la mmoire tampon
Private Const gstrNULL$ = ""                             ' Chane vide
Private Const gstrSEP_DIR$ = ""                         ' Sparateur de dossier
Private Const gstrSEP_URLDIR$ = "/"                      ' Sparateur sparant les dossiers dans les adresses URL.

'-----------------------------------------------------------
' FONCTION: GetWindowsDir
'
' Appelle une fonction API de Windows API pour obtenir le
' dossier et s'assure que le sparateur de dossier est prsent
' en fin de ligne.
'
' Renvoie: Le dossier de Windows.
'-----------------------------------------------------------
'
Public Function GetWindowsDir() As String
    Dim strBuf As String

    strBuf = Space$(gintMAX_SIZE)

    '
    ' Obtient le dossier de Windows et ajuste le tampon  la
    ' longueur exacte renvoye, et ajoute un sparateur de
    ' dossier (barre oblique inverse) si l'API n'a rien renvoy.
    '
    If GetWindowsDirectory(strBuf, gintMAX_SIZE) > 0 Then
        strBuf = StripTerminator$(strBuf)
        AddDirSep strBuf

        GetWindowsDir = strBuf
    Else
        GetWindowsDir = gstrNULL
    End If
End Function

'-----------------------------------------------------------
' FONCTION: GetWindowsSysDir
'
' Appelle une fonction API de Windows pour obtenir le dossier
' systme de Windows et s'assure que le dernier sparateur
' de dossier est ajout.
'
' RENVOIE: le dossier systme de Windows.
'-----------------------------------------------------------
'
Public Function GetWindowsSysDir() As String
    Dim strBuf As String

    strBuf = Space$(gintMAX_SIZE)

    '
    ' Obtient le dossier systme et ajuste le tampon  la longueur
    ' exacte renvoye, et ajoute un sparateur de dossier (barre
    ' oblique inverse) si l'API n'a rien renvoy.
    '
    If GetSystemDirectory(strBuf, gintMAX_SIZE) > 0 Then
        strBuf = StripTerminator(strBuf)
        AddDirSep strBuf
        
        GetWindowsSysDir = strBuf
    Else
        GetWindowsSysDir = gstrNULL
    End If
End Function

'-----------------------------------------------------------
' FONCTION: StripTerminator
'
' Renvoie une chane sans aucun zro  la fin. En gnral,
' il s'agit d'une chane renvoye par un appel  une API de
' Windows.
'
' ENTRE: [strString] - la chane dans laquelle sont supprims les zros.
'
' Renvoie: La valeur de la chane passe, moins les zros de la fin.
'-----------------------------------------------------------
'
Private Function StripTerminator(ByVal strString As String) As String
    Dim intZeroPos As Integer

    intZeroPos = InStr(strString, Chr$(0))
    If intZeroPos > 0 Then
        StripTerminator = Left$(strString, intZeroPos - 1)
    Else
        StripTerminator = strString
    End If
End Function

'-----------------------------------------------------------
' PROCDURE: AddDirSep
' Ajoute un sparateur de chemin de dossier (barre oblique
' inverse)  la fin de la ligne, sauf s'il y en a dj un.
'
' ENTRE/SORTIE: [strPathName] - chemin o ajouter le sparateur.
'-----------------------------------------------------------
'
Private Sub AddDirSep(strPathName As String)
    If Right(Trim(strPathName), Len(gstrSEP_URLDIR)) <> gstrSEP_URLDIR And _
       Right(Trim(strPathName), Len(gstrSEP_DIR)) <> gstrSEP_DIR Then
        strPathName = RTrim$(strPathName) & gstrSEP_DIR
    End If
End Sub


